/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_Certificate(unsigned char *p, size_t len, const Certificate *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* signatureValue */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_bit_string(p, len, &(data)->signatureValue, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_BitString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* signatureAlgorithm */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_AlgorithmIdentifier(p, len, &(data)->signatureAlgorithm, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* tbsCertificate */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_TBSCertificate(p, len, &(data)->tbsCertificate, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_Certificate(const unsigned char *p, size_t len, Certificate *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
e = decode_TBSCertificate(p, len, &(data)->tbsCertificate, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_AlgorithmIdentifier(p, len, &(data)->signatureAlgorithm, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t signatureValue_datalen, signatureValue_oldlen;
Der_type signatureValue_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &signatureValue_type, UT_BitString, &signatureValue_datalen, &l);
if (e == 0 && signatureValue_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
signatureValue_oldlen = len;
if (signatureValue_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = signatureValue_datalen;
e = der_get_bit_string(p, len, &(data)->signatureValue, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = signatureValue_oldlen - signatureValue_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_Certificate(data);
return e;
}

void
free_Certificate(Certificate *data)
{
free_TBSCertificate(&(data)->tbsCertificate);
free_AlgorithmIdentifier(&(data)->signatureAlgorithm);
der_free_bit_string(&(data)->signatureValue);
}

size_t
length_Certificate(const Certificate *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_TBSCertificate(&(data)->tbsCertificate);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_AlgorithmIdentifier(&(data)->signatureAlgorithm);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_bit_string(&(data)->signatureValue);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_Certificate(const Certificate *from, Certificate *to)
{
memset(to, 0, sizeof(*to));
if(copy_TBSCertificate(&(from)->tbsCertificate, &(to)->tbsCertificate)) goto fail;
if(copy_AlgorithmIdentifier(&(from)->signatureAlgorithm, &(to)->signatureAlgorithm)) goto fail;
if(der_copy_bit_string(&(from)->signatureValue, &(to)->signatureValue)) goto fail;
return 0;
fail:
free_Certificate(to);
return ENOMEM;
}



