/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_DirectoryString(unsigned char *p, size_t len, const DirectoryString *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;

switch((data)->element) {
case choice_DirectoryString_bmpString: {size_t Top_oldret = ret;
ret = 0;
e = der_put_bmp_string(p, len, &((data))->u.bmpString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_BMPString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
case choice_DirectoryString_utf8String: {size_t Top_oldret = ret;
ret = 0;
e = der_put_utf8string(p, len, &((data))->u.utf8String, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_UTF8String, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
case choice_DirectoryString_universalString: {size_t Top_oldret = ret;
ret = 0;
e = der_put_universal_string(p, len, &((data))->u.universalString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_GraphicString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
case choice_DirectoryString_printableString: {size_t Top_oldret = ret;
ret = 0;
e = der_put_printable_string(p, len, &((data))->u.printableString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_PrintableString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
case choice_DirectoryString_teletexString: {size_t Top_oldret = ret;
ret = 0;
e = der_put_general_string(p, len, &((data))->u.teletexString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_TeletexString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
case choice_DirectoryString_ia5String: {size_t Top_oldret = ret;
ret = 0;
e = der_put_ia5_string(p, len, &((data))->u.ia5String, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_IA5String, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
};
*size = ret;
return 0;
}

int
decode_DirectoryString(const unsigned char *p, size_t len, DirectoryString *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
if (der_match_tag(p, len, ASN1_C_UNIV, PRIM, UT_IA5String, NULL) == 0) {
{
size_t ia5String_datalen, ia5String_oldlen;
Der_type ia5String_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &ia5String_type, UT_IA5String, &ia5String_datalen, &l);
if (e == 0 && ia5String_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
ia5String_oldlen = len;
if (ia5String_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = ia5String_datalen;
e = der_get_ia5_string(p, len, &(data)->u.ia5String, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = ia5String_oldlen - ia5String_datalen;
}
(data)->element = choice_DirectoryString_ia5String;
}
else if (der_match_tag(p, len, ASN1_C_UNIV, PRIM, UT_TeletexString, NULL) == 0) {
{
size_t teletexString_datalen, teletexString_oldlen;
Der_type teletexString_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &teletexString_type, UT_TeletexString, &teletexString_datalen, &l);
if (e == 0 && teletexString_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
teletexString_oldlen = len;
if (teletexString_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = teletexString_datalen;
e = der_get_general_string(p, len, &(data)->u.teletexString, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = teletexString_oldlen - teletexString_datalen;
}
(data)->element = choice_DirectoryString_teletexString;
}
else if (der_match_tag(p, len, ASN1_C_UNIV, PRIM, UT_PrintableString, NULL) == 0) {
{
size_t printableString_datalen, printableString_oldlen;
Der_type printableString_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &printableString_type, UT_PrintableString, &printableString_datalen, &l);
if (e == 0 && printableString_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
printableString_oldlen = len;
if (printableString_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = printableString_datalen;
e = der_get_printable_string(p, len, &(data)->u.printableString, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = printableString_oldlen - printableString_datalen;
}
(data)->element = choice_DirectoryString_printableString;
}
else if (der_match_tag(p, len, ASN1_C_UNIV, PRIM, UT_GraphicString, NULL) == 0) {
{
size_t universalString_datalen, universalString_oldlen;
Der_type universalString_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &universalString_type, UT_GraphicString, &universalString_datalen, &l);
if (e == 0 && universalString_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
universalString_oldlen = len;
if (universalString_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = universalString_datalen;
e = der_get_universal_string(p, len, &(data)->u.universalString, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = universalString_oldlen - universalString_datalen;
}
(data)->element = choice_DirectoryString_universalString;
}
else if (der_match_tag(p, len, ASN1_C_UNIV, PRIM, UT_UTF8String, NULL) == 0) {
{
size_t utf8String_datalen, utf8String_oldlen;
Der_type utf8String_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &utf8String_type, UT_UTF8String, &utf8String_datalen, &l);
if (e == 0 && utf8String_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
utf8String_oldlen = len;
if (utf8String_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = utf8String_datalen;
e = der_get_utf8string(p, len, &(data)->u.utf8String, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = utf8String_oldlen - utf8String_datalen;
}
(data)->element = choice_DirectoryString_utf8String;
}
else if (der_match_tag(p, len, ASN1_C_UNIV, PRIM, UT_BMPString, NULL) == 0) {
{
size_t bmpString_datalen, bmpString_oldlen;
Der_type bmpString_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &bmpString_type, UT_BMPString, &bmpString_datalen, &l);
if (e == 0 && bmpString_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
bmpString_oldlen = len;
if (bmpString_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = bmpString_datalen;
e = der_get_bmp_string(p, len, &(data)->u.bmpString, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = bmpString_oldlen - bmpString_datalen;
}
(data)->element = choice_DirectoryString_bmpString;
}
else {
e = ASN1_PARSE_ERROR;
goto fail;
}
if(size) *size = ret;
return 0;
fail:
free_DirectoryString(data);
return e;
}

void
free_DirectoryString(DirectoryString *data)
{
switch((data)->element) {
case choice_DirectoryString_ia5String:
der_free_ia5_string(&(data)->u.ia5String);
break;
case choice_DirectoryString_teletexString:
der_free_general_string(&(data)->u.teletexString);
break;
case choice_DirectoryString_printableString:
der_free_printable_string(&(data)->u.printableString);
break;
case choice_DirectoryString_universalString:
der_free_universal_string(&(data)->u.universalString);
break;
case choice_DirectoryString_utf8String:
der_free_utf8string(&(data)->u.utf8String);
break;
case choice_DirectoryString_bmpString:
der_free_bmp_string(&(data)->u.bmpString);
break;
}
}

size_t
length_DirectoryString(const DirectoryString *data)
{
size_t ret = 0;
switch((data)->element) {
case choice_DirectoryString_ia5String:
{
size_t Top_oldret = ret;
ret = 0;
ret += der_length_ia5_string(&(data)->u.ia5String);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
case choice_DirectoryString_teletexString:
{
size_t Top_oldret = ret;
ret = 0;
ret += der_length_general_string(&(data)->u.teletexString);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
case choice_DirectoryString_printableString:
{
size_t Top_oldret = ret;
ret = 0;
ret += der_length_printable_string(&(data)->u.printableString);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
case choice_DirectoryString_universalString:
{
size_t Top_oldret = ret;
ret = 0;
ret += der_length_universal_string(&(data)->u.universalString);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
case choice_DirectoryString_utf8String:
{
size_t Top_oldret = ret;
ret = 0;
ret += der_length_utf8string(&(data)->u.utf8String);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
case choice_DirectoryString_bmpString:
{
size_t Top_oldret = ret;
ret = 0;
ret += der_length_bmp_string(&(data)->u.bmpString);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
}
return ret;
}

int
copy_DirectoryString(const DirectoryString *from, DirectoryString *to)
{
memset(to, 0, sizeof(*to));
(to)->element = (from)->element;
switch((from)->element) {
case choice_DirectoryString_ia5String:
if(der_copy_ia5_string(&(from)->u.ia5String, &(to)->u.ia5String)) goto fail;
break;
case choice_DirectoryString_teletexString:
if(der_copy_general_string(&(from)->u.teletexString, &(to)->u.teletexString)) goto fail;
break;
case choice_DirectoryString_printableString:
if(der_copy_printable_string(&(from)->u.printableString, &(to)->u.printableString)) goto fail;
break;
case choice_DirectoryString_universalString:
if(der_copy_universal_string(&(from)->u.universalString, &(to)->u.universalString)) goto fail;
break;
case choice_DirectoryString_utf8String:
if(der_copy_utf8string(&(from)->u.utf8String, &(to)->u.utf8String)) goto fail;
break;
case choice_DirectoryString_bmpString:
if(der_copy_bmp_string(&(from)->u.bmpString, &(to)->u.bmpString)) goto fail;
break;
}
return 0;
fail:
free_DirectoryString(to);
return ENOMEM;
}



