/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_ECParameters(unsigned char *p, size_t len, const ECParameters *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;

switch((data)->element) {
case choice_ECParameters_namedCurve: {size_t Top_oldret = ret;
ret = 0;
e = der_put_oid(p, len, &((data))->u.namedCurve, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OID, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_oldret;
break;
}
};
*size = ret;
return 0;
}

int
decode_ECParameters(const unsigned char *p, size_t len, ECParameters *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
if (der_match_tag(p, len, ASN1_C_UNIV, PRIM, UT_OID, NULL) == 0) {
{
size_t namedCurve_datalen, namedCurve_oldlen;
Der_type namedCurve_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &namedCurve_type, UT_OID, &namedCurve_datalen, &l);
if (e == 0 && namedCurve_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
namedCurve_oldlen = len;
if (namedCurve_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = namedCurve_datalen;
e = der_get_oid(p, len, &(data)->u.namedCurve, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = namedCurve_oldlen - namedCurve_datalen;
}
(data)->element = choice_ECParameters_namedCurve;
}
else {
e = ASN1_PARSE_ERROR;
goto fail;
}
if(size) *size = ret;
return 0;
fail:
free_ECParameters(data);
return e;
}

void
free_ECParameters(ECParameters *data)
{
switch((data)->element) {
case choice_ECParameters_namedCurve:
der_free_oid(&(data)->u.namedCurve);
break;
}
}

size_t
length_ECParameters(const ECParameters *data)
{
size_t ret = 0;
switch((data)->element) {
case choice_ECParameters_namedCurve:
{
size_t Top_oldret = ret;
ret = 0;
ret += der_length_oid(&(data)->u.namedCurve);
ret += 1 + der_length_len (ret);
ret += Top_oldret;
}
break;
}
return ret;
}

int
copy_ECParameters(const ECParameters *from, ECParameters *to)
{
memset(to, 0, sizeof(*to));
(to)->element = (from)->element;
switch((from)->element) {
case choice_ECParameters_namedCurve:
if(der_copy_oid(&(from)->u.namedCurve, &(to)->u.namedCurve)) goto fail;
break;
}
return 0;
fail:
free_ECParameters(to);
return ENOMEM;
}



