/* Generated from ./cms.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <cms_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_EncryptedContentInfo(unsigned char *p, size_t len, const EncryptedContentInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* encryptedContent */
if((data)->encryptedContent) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, (data)->encryptedContent, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, PRIM, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* contentEncryptionAlgorithm */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_ContentEncryptionAlgorithmIdentifier(p, len, &(data)->contentEncryptionAlgorithm, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* contentType */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_ContentType(p, len, &(data)->contentType, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_EncryptedContentInfo(const unsigned char *p, size_t len, EncryptedContentInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_Sequence, &Top_datalen, &l);
if (e == 0 && Top_type != CONS) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if((is_indefinite = _heim_fix_dce(Top_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }e = decode_ContentType(p, len, &(data)->contentType, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_ContentEncryptionAlgorithmIdentifier(p, len, &(data)->contentEncryptionAlgorithm, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t encryptedContent_datalen, encryptedContent_oldlen;
Der_type encryptedContent_type;
int is_indefinite;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, &encryptedContent_type, 0, &encryptedContent_datalen, &l);
if(e) {
(data)->encryptedContent = NULL;
} else {
(data)->encryptedContent = calloc(1, sizeof(*(data)->encryptedContent));
if ((data)->encryptedContent == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
encryptedContent_oldlen = len;
if((is_indefinite = _heim_fix_dce(encryptedContent_datalen, &len)) < 0)
{ e = ASN1_BAD_FORMAT; goto fail; }
if (is_indefinite) { if (len < 2) { e = ASN1_OVERRUN; goto fail; } len -= 2; }if (encryptedContent_type == CONS) {
e = der_get_octet_string_ber(p, len, (data)->encryptedContent, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
} else {
e = der_get_octet_string(p, len, (data)->encryptedContent, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
}
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &encryptedContent_type, UT_EndOfContent, &encryptedContent_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (encryptedContent_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = encryptedContent_oldlen - encryptedContent_datalen;
}
}
if(is_indefinite){
len += 2;
e = der_match_tag_and_length(p, len, (Der_class)0, &Top_type, UT_EndOfContent, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
if (Top_type != (Der_type)0) { e = ASN1_BAD_ID; goto fail; }
} else 
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_EncryptedContentInfo(data);
return e;
}

void
free_EncryptedContentInfo(EncryptedContentInfo *data)
{
free_ContentType(&(data)->contentType);
free_ContentEncryptionAlgorithmIdentifier(&(data)->contentEncryptionAlgorithm);
if((data)->encryptedContent) {
der_free_octet_string((data)->encryptedContent);
free((data)->encryptedContent);
(data)->encryptedContent = NULL;
}
}

size_t
length_EncryptedContentInfo(const EncryptedContentInfo *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_ContentType(&(data)->contentType);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_ContentEncryptionAlgorithmIdentifier(&(data)->contentEncryptionAlgorithm);
ret += Top_tag_oldret;
}
if((data)->encryptedContent){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string((data)->encryptedContent);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_EncryptedContentInfo(const EncryptedContentInfo *from, EncryptedContentInfo *to)
{
memset(to, 0, sizeof(*to));
if(copy_ContentType(&(from)->contentType, &(to)->contentType)) goto fail;
if(copy_ContentEncryptionAlgorithmIdentifier(&(from)->contentEncryptionAlgorithm, &(to)->contentEncryptionAlgorithm)) goto fail;
if((from)->encryptedContent) {
(to)->encryptedContent = malloc(sizeof(*(to)->encryptedContent));
if((to)->encryptedContent == NULL) goto fail;
if(der_copy_octet_string((from)->encryptedContent, (to)->encryptedContent)) goto fail;
}else
(to)->encryptedContent = NULL;
return 0;
fail:
free_EncryptedContentInfo(to);
return ENOMEM;
}



