/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_KeyUsage(unsigned char *p, size_t len, const KeyUsage *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
{
unsigned char c = 0;
int rest = 0;
int bit_set = 0;
if((data)->decipherOnly) {
c |= 1<<7;
}
if (c != 0 || bit_set) {
if (len < 1) return ASN1_OVERFLOW;
*p-- = c; len--; ret++;
if (!bit_set) {
rest = 0;
while(c) { 
if (c & 1) break;
c = c >> 1;
rest++;
}
bit_set = 1;
}
}
c = 0;
if((data)->encipherOnly) {
c |= 1<<0;
}
if((data)->cRLSign) {
c |= 1<<1;
}
if((data)->keyCertSign) {
c |= 1<<2;
}
if((data)->keyAgreement) {
c |= 1<<3;
}
if((data)->dataEncipherment) {
c |= 1<<4;
}
if((data)->keyEncipherment) {
c |= 1<<5;
}
if((data)->nonRepudiation) {
c |= 1<<6;
}
if((data)->digitalSignature) {
c |= 1<<7;
}
if (c != 0 || bit_set) {
if (len < 1) return ASN1_OVERFLOW;
*p-- = c; len--; ret++;
if (!bit_set) {
rest = 0;
if(c) { 
while(c) { 
if (c & 1) break;
c = c >> 1;
rest++;
}
}
}
}
if (len < 1) return ASN1_OVERFLOW;
*p-- = rest;
len -= 1;
ret += 1;
}

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_BitString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_KeyUsage(const unsigned char *p, size_t len, KeyUsage *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
Der_type Top_type;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, &Top_type, UT_BitString, &Top_datalen, &l);
if (e == 0 && Top_type != PRIM) { e = ASN1_BAD_ID; }
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
if (len < 1) return ASN1_OVERRUN;
p++; len--; ret++;
do {
if (len < 1) break;
(data)->digitalSignature = (*p >> 7) & 1;
(data)->nonRepudiation = (*p >> 6) & 1;
(data)->keyEncipherment = (*p >> 5) & 1;
(data)->dataEncipherment = (*p >> 4) & 1;
(data)->keyAgreement = (*p >> 3) & 1;
(data)->keyCertSign = (*p >> 2) & 1;
(data)->cRLSign = (*p >> 1) & 1;
(data)->encipherOnly = (*p >> 0) & 1;
p++; len--; ret++;
if (len < 1) break;
(data)->decipherOnly = (*p >> 7) & 1;
} while(0);
p += len; ret += len;
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_KeyUsage(data);
return e;
}

void
free_KeyUsage(KeyUsage *data)
{
}

size_t
length_KeyUsage(const KeyUsage *data)
{
size_t ret = 0;
do {
if((data)->decipherOnly) { ret += 2; break; }
if((data)->encipherOnly) { ret += 1; break; }
if((data)->cRLSign) { ret += 1; break; }
if((data)->keyCertSign) { ret += 1; break; }
if((data)->keyAgreement) { ret += 1; break; }
if((data)->dataEncipherment) { ret += 1; break; }
if((data)->keyEncipherment) { ret += 1; break; }
if((data)->nonRepudiation) { ret += 1; break; }
if((data)->digitalSignature) { ret += 1; break; }
} while(0);
ret += 1;
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_KeyUsage(const KeyUsage *from, KeyUsage *to)
{
memset(to, 0, sizeof(*to));
*(to) = *(from);
return 0;
}

unsigned KeyUsage2int(KeyUsage f)
{
unsigned r = 0;
if(f.digitalSignature) r |= (1U << 0);
if(f.nonRepudiation) r |= (1U << 1);
if(f.keyEncipherment) r |= (1U << 2);
if(f.dataEncipherment) r |= (1U << 3);
if(f.keyAgreement) r |= (1U << 4);
if(f.keyCertSign) r |= (1U << 5);
if(f.cRLSign) r |= (1U << 6);
if(f.encipherOnly) r |= (1U << 7);
if(f.decipherOnly) r |= (1U << 8);
return r;
}

KeyUsage int2KeyUsage(unsigned n)
{
	KeyUsage flags;

	flags.digitalSignature = (n >> 0) & 1;
	flags.nonRepudiation = (n >> 1) & 1;
	flags.keyEncipherment = (n >> 2) & 1;
	flags.dataEncipherment = (n >> 3) & 1;
	flags.keyAgreement = (n >> 4) & 1;
	flags.keyCertSign = (n >> 5) & 1;
	flags.cRLSign = (n >> 6) & 1;
	flags.encipherOnly = (n >> 7) & 1;
	flags.decipherOnly = (n >> 8) & 1;
	return flags;
}

static struct units KeyUsage_units[] = {
	{"decipherOnly",	1U << 8},
	{"encipherOnly",	1U << 7},
	{"cRLSign",	1U << 6},
	{"keyCertSign",	1U << 5},
	{"keyAgreement",	1U << 4},
	{"dataEncipherment",	1U << 3},
	{"keyEncipherment",	1U << 2},
	{"nonRepudiation",	1U << 1},
	{"digitalSignature",	1U << 0},
	{NULL,	0}
};

const struct units * asn1_KeyUsage_units(void){
return KeyUsage_units;
}



